<!DOCTYPE html><html lang="en"><head><meta charSet="utf-8"/><meta http-equiv="X-UA-Compatible" content="IE=edge"/><title>Hello World Tutorial · Merge</title><meta name="viewport" content="width=device-width"/><meta name="generator" content="Docusaurus"/><meta name="description" content="&lt;p&gt;Our hello-world experiment is two nodes connected by a network link that engage in a hello-world conversation. For a pre-canned environment that contains everything necessary to follow along check out the &lt;a href=&quot;https://quay.io/repository/mergetb/xdc&quot;&gt;experiment development container&lt;/a&gt;.&lt;/p&gt;
"/><meta name="docsearch:language" content="en"/><meta property="og:title" content="Hello World Tutorial · Merge"/><meta property="og:type" content="website"/><meta property="og:url" content="https://mergetb.gitlab.io/index.html"/><meta property="og:description" content="&lt;p&gt;Our hello-world experiment is two nodes connected by a network link that engage in a hello-world conversation. For a pre-canned environment that contains everything necessary to follow along check out the &lt;a href=&quot;https://quay.io/repository/mergetb/xdc&quot;&gt;experiment development container&lt;/a&gt;.&lt;/p&gt;
"/><meta property="og:image" content="https://mergetb.gitlab.io/img/logo.png"/><meta name="twitter:card" content="summary"/><meta name="twitter:image" content="https://mergetb.gitlab.io/img/logo.png"/><link rel="shortcut icon" href="/img/merge.png"/><link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/dracula.min.css"/><link rel="alternate" type="application/atom+xml" href="https://mergetb.gitlab.io/blog/atom.xml" title="Merge Blog ATOM Feed"/><link rel="alternate" type="application/rss+xml" href="https://mergetb.gitlab.io/blog/feed.xml" title="Merge Blog RSS Feed"/><script type="text/javascript" src="https://buttons.github.io/buttons.js"></script><link rel="stylesheet" href="/css/main.css"/></head><body class="sideNavVisible separateOnPageNav"><div class="fixedHeaderContainer"><div class="headerWrapper wrapper"><header><a href="/"><img class="logo" src="/img/merge-light.svg" alt="Merge"/><h2 class="headerTitleWithLogo">Merge</h2></a><div class="navigationWrapper navigationSlider"><nav class="slidingNav"><ul class="nav-site nav-site-internal"><li class="siteNavGroupActive"><a href="/docs/hello-world.html" target="_self">Experimentation</a></li><li class=""><a href="/docs/site-basics.html" target="_self">Site Hosting</a></li><li class=""><a href="/docs/portal-admin.html" target="_self">Portal Hosting</a></li><li class=""><a href="/docs/tech.html" target="_self">Technology</a></li><li class=""><a href="/blog/" target="_self">News</a></li></ul></nav></div></header></div></div><div class="navPusher"><div class="docMainWrapper wrapper"><div class="container docsNavContainer" id="docsNav"><nav class="toc"><div class="toggleNav"><section class="navWrapper wrapper"><div class="navBreadcrumb wrapper"><div class="navToggle" id="navToggler"><i></i></div><h2><i>›</i><span>Getting Started</span></h2><div class="tocToggler" id="tocToggler"><i class="icon-toc"></i></div></div><div class="navGroups"><div class="navGroup"><h3 class="navGroupCategoryTitle">Getting Started</h3><ul><li class="navListItem"><a class="navItem" href="/docs/hello-world.html">Hello World tl;dr</a></li><li class="navListItem navListItemActive"><a class="navItem" href="/docs/hello-world-tutorial.html">Hello World Tutorial</a></li></ul></div><div class="navGroup"><h3 class="navGroupCategoryTitle">Examples</h3><ul><li class="navListItem"><a class="navItem" href="/docs/snowflake.html">Snowflake</a></li></ul></div><div class="navGroup"><h3 class="navGroupCategoryTitle">Reference</h3><ul><li class="navListItem"><a class="navItem" href="/docs/merge-api.html">Merge API</a></li><li class="navListItem"><a class="navItem" href="/docs/toporef.html">Topology</a></li><li class="navListItem"><a class="navItem" href="/docs/well-known.html">Well Known Properties</a></li><li class="navListItem"><a class="navItem" href="/docs/image-support.html">Image Support</a></li></ul></div></div></section></div><script>
            document.addEventListener('DOMContentLoaded', function() {
              createToggler('#navToggler', '#docsNav', 'docsSliderActive');
              createToggler('#tocToggler', 'body', 'tocActive');

              const headings = document.querySelector('.toc-headings');
              headings && headings.addEventListener('click', function(event) {
                if (event.target.tagName === 'A') {
                  document.body.classList.remove('tocActive');
                }
              }, false);

              function createToggler(togglerSelector, targetSelector, className) {
                var toggler = document.querySelector(togglerSelector);
                var target = document.querySelector(targetSelector);

                if (!toggler) {
                  return;
                }

                toggler.onclick = function(event) {
                  event.preventDefault();

                  target.classList.toggle(className);
                };
              }
            });
        </script></nav></div><div class="container mainContainer"><div class="wrapper"><div class="post"><header class="postHeader"><h1 class="postHeaderTitle">Hello World Tutorial</h1></header><article><div><span><p>Our hello-world experiment is two nodes connected by a network link that engage in a hello-world conversation. For a pre-canned environment that contains everything necessary to follow along check out the <a href="https://quay.io/repository/mergetb/xdc">experiment development container</a>.</p>
<p><img src="/img/hello-diagram.png" style="max-height: 200px" /></p>
<p>Experiments go through an iterative process of</p>
<p><a href="#design">Design</a> : Express your experiment.
<br/>
<a href="#realization">Realize</a> : Gather resource for your experiment.
<br/>
<a href="#materialization">Materialize</a> : Bring your experiment to life.
<br/>
<a href="#access">Access</a> &amp; <a href="#execution">Execution</a> : Get onto your experiment networks and run your scenarios.</p>
<h2><a class="anchor" aria-hidden="true" id="design"></a><a href="#design" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Design</h2>
<p>Experiments begin with a <a href="/docs/toporef.html#Network">Network</a> topology. Topologies in Merge are designed using the <a href="/docs/toporef.html">xir</a> library.</p>
<pre><code class="hljs css language-python"><span class="hljs-keyword">import</span> xir, mergetb

topo = xir.Network({<span class="hljs-string">'name'</span>: <span class="hljs-string">'hello-world'</span>})
a = topo.node({<span class="hljs-string">'name'</span>: <span class="hljs-string">'a'</span>})
b = topo.node({<span class="hljs-string">'name'</span>: <span class="hljs-string">'b'</span>})

topo.connect(a, b)
</code></pre>
<h4><a class="anchor" aria-hidden="true" id="push"></a><a href="#push" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Push</h4>
<p>Once a topology has been designed, it can be associated with an experiment. This is done by <a href="/docs/merge-api.html#pushTopology">pushing</a> the topology to an experiment using the <a href="/docs/merge-api.html">mergetb</a> library. Experiment topologies are versioned, every time you push a topology a new version is created.</p>
<pre><code class="hljs css language-python">xp = mergetb.pushTopology(project=<span class="hljs-string">'hello'</span>, experiment=<span class="hljs-string">'world'</span>, topo)
</code></pre>
<h2><a class="anchor" aria-hidden="true" id="realization"></a><a href="#realization" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Realization</h2>
<p>Now that our experiment has a topology definition, the next thing we need to do is allocate the resources needed to <a href="/docs/merge-api.html#realize">realize</a> this experiment. This is called realization. A realization may not succeed if sufficient resources are not available.</p>
<pre><code class="hljs css language-python">rz = mergetb.realize(project=<span class="hljs-string">'hello'</span>, experiment=<span class="hljs-string">'world'</span>, xp.hash)
</code></pre>
<h2><a class="anchor" aria-hidden="true" id="materialization"></a><a href="#materialization" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Materialization</h2>
<p>Now that the experiment has been realized, we can <a href="/docs/merge-api.html#materialize">materialize</a> it. Materialization is the process of provisioning the resources that were allocated in the realization phase. In our example this includes imaging 2 nodes with fresh operating systems, setting their hostnames, creating a virtual isolated network link between them and connecting them to a control network for experimenter access.</p>
<pre><code class="hljs css language-python">mz = mergetb.materialize(project=<span class="hljs-string">'hello'</span>, experiment=<span class="hljs-string">'world'</span>, rz.id)
</code></pre>
<h2><a class="anchor" aria-hidden="true" id="access"></a><a href="#access" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Access</h2>
<p>To get going we need to login to the merge portal.</p>
<pre><code class="hljs css language-shell"><span class="hljs-meta">$</span><span class="bash"> mergetb login <span class="hljs-string">'murphy'</span> <span class="hljs-string">'password'</span></span>
</code></pre>
<p>Next, wrap up the above into a python script called <code>hello-world.py</code> and start the materialization process by executing it.</p>
<pre><code class="hljs css language-shell"><span class="hljs-meta">$</span><span class="bash"> python3 hello-world.py</span>
</code></pre>
<p>We can now access the control network of the experiment via a VPN connection. Merge provides a set of command line tools to easily do this. These tools are included in the <a href="https://quay.io/repository/mergetb/xdc">experiment development container</a> base image.</p>
<pre><code class="hljs css language-shell"><span class="hljs-meta">$</span><span class="bash"> mergetb connect <span class="hljs-string">'hello'</span> <span class="hljs-string">'world'</span></span>
local control net ip: 172.16.0.1
</code></pre>
<p>We now have access to the control net, but the nodes may still be materializing. A good way to see when the nodes are available is to ping them.</p>
<pre><code class="hljs css language-shell"><span class="hljs-meta">$</span><span class="bash"> ping a</span>
PING a (172.16.0.47) 56(84) bytes of data.
</code></pre>
<p>The name <code>'a'</code> is resolved by the experiment DNS server that is a part of the control net VPN. When you start seeing responses from the ping the node is alive and ready to go.</p>
<pre><code class="hljs css language-shell"><span class="hljs-meta">$</span><span class="bash"> ssh a</span>
<span class="hljs-meta">
root@a$</span><span class="bash"> _</span>
</code></pre>
<h2><a class="anchor" aria-hidden="true" id="execution"></a><a href="#execution" aria-hidden="true" class="hash-link"><svg class="hash-link-icon" aria-hidden="true" height="16" version="1.1" viewBox="0 0 16 16" width="16"><path fill-rule="evenodd" d="M4 9h1v1H4c-1.5 0-3-1.69-3-3.5S2.55 3 4 3h4c1.45 0 3 1.69 3 3.5 0 1.41-.91 2.72-2 3.25V8.59c.58-.45 1-1.27 1-2.09C10 5.22 8.98 4 8 4H4c-.98 0-2 1.22-2 2.5S3 9 4 9zm9-3h-1v1h1c1 0 2 1.22 2 2.5S13.98 12 13 12H9c-.98 0-2-1.22-2-2.5 0-.83.42-1.64 1-2.09V6.25c-1.09.53-2 1.84-2 3.25C6 11.31 7.55 13 9 13h4c1.45 0 3-1.69 3-3.5S14.5 6 13 6z"></path></svg></a>Execution</h2>
<p>Now lets have the two nodes exchange the obligatory greeting.</p>
<p>Start by listening for messages on port <code>4747</code> on node <code>b</code>.</p>
<pre><code class="hljs css language-shell"><span class="hljs-meta">root@b$</span><span class="bash">: nc -lkp 4747 -c <span class="hljs-string">'read message; printf "$message\n" &gt;&amp;2; echo "world"'</span></span>
</code></pre>
<p>Now from node <code>a</code> send a <code>'hello'</code> message and see the <code>'world'</code> response. In <code>b</code>'s terminal, you will also see the <code>'hello'</code> text printed.</p>
<pre><code class="hljs css language-shell"><span class="hljs-meta">root@a$</span><span class="bash">: (<span class="hljs-built_in">echo</span> hello; sleep 2) | nc a.xp 4747</span>
world
</code></pre>
<p>Notice the use of the name <code>a.xp.</code> All experiments come with two networks by default an experiment network and a control network. The experiment network is the one that we defined in our topology and is accessible under the domain <code>.xp.</code> The control network is a flat network that interconnects all the nodes in an experiment for things like node access and automation runs. When we logged into our nodes through <code>ssh</code> we did so using the control network. The control network is accessible under the domain <code>.ct.</code></p>
</span></div></article></div><div class="docs-prevnext"><a class="docs-prev button" href="/docs/hello-world.html"><span class="arrow-prev">← </span><span>Hello World tl;dr</span></a><a class="docs-next button" href="/docs/snowflake.html"><span>Snowflake</span><span class="arrow-next"> →</span></a></div></div></div><nav class="onPageNav"><ul class="toc-headings"><li><a href="#design">Design</a></li><li><a href="#realization">Realization</a></li><li><a href="#materialization">Materialization</a></li><li><a href="#access">Access</a></li><li><a href="#execution">Execution</a></li></ul></nav></div><footer class="nav-footer" id="footer"><section class="sitemap"><a href="/" class="nav-home"><img src="/img/merge-light.svg" alt="Merge" width="66" height="58"/></a><div><h5>Docs</h5><a href="/docs/en/hello-world.html">Experimentation</a><a href="/docs/en/site-basics.html">Site Hosting</a><a href="/docs/en/portal-admin.html">Portal Hosting</a></div><div><h5>Community</h5><a href="/en/users.html">User Showcase</a><a href="https://mergetb.slack.com/">Project Chat</a></div><div><h5>More</h5><a href="/blog">Blog</a><a href="https://gitlab.com/mergetb">GitLab</a></div></section><section class="copyright">Copyright © 2018 Information Sciences Institute</section></footer></div></body></html>